/**
 * \file clause.cpp
 * \author Léo Perrin
 * \date 2011/11/22
 */

#include <stdlib.h>
#include <vector>
#include <string>
#include <sstream>
#include <iostream>

#include "clause.h"

// This class has the exit codes 2xx

Clause::Clause()
{
	literals.clear();
}

void Clause::addLit(int code)
{
	literals.push_back(code);
}

std::string Clause::toString()
{
	std::stringstream s(std::stringstream::out);
	for (unsigned int i=0; i<literals.size(); i++)
	{
		s << literals[i] << " ";
	}
	std::string res = s.str() + "0";
	s.flush();
	return res;
}

bool Clause::restriction(std::vector<int> assign)
{
	for (unsigned int i=0; i<assign.size(); i++)
		for (unsigned int j=0; j<literals.size(); j++)
			if (assign[i] == (-1)*literals[j])
				// case where the literal in the clause is negated in
				// the assignment: we remove it from the clause
				literals.erase(literals.begin()+j);
			else if (assign[i] == literals[j])
				// case where the literal is in the assignment: the CNF
				// clause is thus true
				return 1;
	if (literals.size() == 0)
	{
		// case where the empty clause was derived using the assignment
		std::cout<< "Error 200: The restriction falsifies the formula,"
			 << " no solution." << std::endl;
		exit(200);
	}
	return 0;
}
